

#include "kwlanmainwin.h"
#include "wlanlib.h"
#include "kprofileconfigdlg.h"
#include "kstartsupplicantdlg.h"
#include "wpa_ctrl.h"
#include "keventhistorydlg.h"
#include "kscandlg.h"
#include "kuserdatarequestdlg.h"
#include "kwlansettingsdlg.h"
#include "kwlansuprocess.h"
#include "kwlaninterface.h"
#include "dialup.h"
#include "kdialup.h"
#include "kdialupconfigdlg.h"
#include "kwlanmaintraywin.h"
#include "configuration.h"


#include <iostream>
#include <kstdaction.h>
#include <kaction.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qapplication.h>
#include <qtimer.h>
#include <qlabel.h>
#include <qaction.h>
#include <unistd.h>
#include <dirent.h>
#include <klocale.h>
#include <qstringlist.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <kaboutapplication.h>
#include <qcstring.h>
#include <kpassdlg.h>
#include <kmessagebox.h>
#include <ktempfile.h>
#include <kstandarddirs.h>
#include <kpassdlg.h>
#include <kdebug.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include <kprocess.h>


KWlanMainWin::KWlanMainWin(QWidget* parent, const char* name, WFlags fl)
    : Kwlan(parent,name,fl)
{
    m_ifconfigProcess=0L;
}

int KWlanMainWin::init() 
{
    
    //if (!m_configuration->m_startMinimized) 
    //    show();
    
    // now update Dialup Networks
    updateDialupNetworks();
    m_tray = new KWlanMainTrayWin( this, "KWlan" );
    m_tray->show();
    connect( m_tray, SIGNAL( quitSelected() ), this, SLOT( fileExit() ) );
    connect(m_tray, SIGNAL (aboutSelected() ),this, SLOT(helpAbout()));
    slotCheckInterfaces();
    m_timer = new QTimer(this);
    if (m_timer){
        connect (m_timer, SIGNAL(timeout()),SLOT(slotCheckInterfaces()));
        m_timer->start(5000,FALSE);
    }

    return 0;
}

KWlanMainWin::~KWlanMainWin()
{
    if (m_timer)
        delete m_timer;
    m_configuration->writeSettings();
}


void KWlanMainWin::slotCheckInterfaces()
{
    if (m_ifconfigProcess) return;
    m_ifconfigStdout=QString::null;
    m_ifconfigProcess = new KProcess();
    m_ifconfigProcess->setEnvironment( "LANG", "C" );
    m_ifconfigProcess->setEnvironment( "LC_ALL", "C" );
    //TODO: use path to ifconfig
    *m_ifconfigProcess << "ifconfig" << "-a";
    connect( m_ifconfigProcess,  SIGNAL( receivedStdout( KProcess*, char*, int ) ),
             this, SLOT( ifconfigProcessStdout( KProcess*, char*, int ) ) );
    connect( m_ifconfigProcess,  SIGNAL( processExited( KProcess* ) ),
             this, SLOT( ifconfigProcessExited( KProcess* ) ) );

    if ( !m_ifconfigProcess->start( KProcess::NotifyOnExit, KProcess::Stdout ) )
    {
        delete m_ifconfigProcess;
        m_ifconfigProcess = 0L;
    }
}
/*$SPECIALIZATION$*/
void KWlanMainWin::dialupNew()
{
    KDialupConfigDlg *conf = new KDialupConfigDlg();
    connect (conf, SIGNAL(dialupNetworksUpdated()),this, SLOT(updateDialupNetworks()));
    conf->show();
}

void KWlanMainWin::dialupDelete()
{
    QListBoxItem *selected = lbDialup->selectedItem();
    // check if a profile is selected
    if (!selected) {
        KMessageBox::sorry(this,i18n("No network selected!"));
        return;
    }
    int answer = KMessageBox::warningYesNo(this,i18n("Do you really want to delete this profile?"));
    if (answer==KMessageBox::Yes){
        QString filename = QString(PPP_PEERS) + QString("/") + lbDialup->currentText();
        KWlanSuProcess *proc = new KWlanSuProcess();
        *proc << "rm" << filename;
        proc->setDescription( i18n("delete dialup network"));
        updateDialupNetworks();
        proc->start();
    }
}

void KWlanMainWin::dialupModify()
{
    // get network
    QListBoxItem *selected = lbDialup->selectedItem();
    // check if a profile is selected
    if (!selected) {
        KMessageBox::sorry(this,i18n("No network selected!"));
        return;
    }
    
    QString sel(lbDialup->currentText());
    KDialupConfigDlg *conf = new KDialupConfigDlg();
    connect (conf, SIGNAL(dialupNetworksUpdated()),this, SLOT(updateDialupNetworks()));
    if (conf->init(sel))
        conf->show();
        else delete conf;
}

void KWlanMainWin::dialupDisconnect()
{
    // get network
    QListBoxItem *selected = lbDialup->selectedItem();
    // check if a profile is selected
    if (!selected) {
        KMessageBox::sorry(this,i18n("No network selected!"));
        return;
    }
    
    QString sel(lbDialup->currentText());
    KDialup *tmpDial = new KDialup;
    tmpDial->disconnectNetwork(sel);
    delete tmpDial;
    

}

void KWlanMainWin::dialupConnect()
{
    // get network
    QListBoxItem *selected = lbDialup->selectedItem();
    // check if a profile is selected
    if (!selected) {
        KMessageBox::sorry(this,i18n("No network selected!"));
        return;
    }
    KDialup *dialup = new KDialup();
    QString sel(lbDialup->currentText());
    dialup->connectNetwork(sel);

}







void KWlanMainWin::editSettings()
{
    /*
    KWlanSettingsDlg *settings = new KWlanSettingsDlg();
    settings->cbWpa->setChecked(m_configuration->m_startWpa);
    settings->cbWpaNoQuestion->setChecked(m_configuration->m_startWpaNoQuestion);
    settings->cbMinimized->setChecked(m_configuration->m_startMinimized);
    settings->sbPasswordTime->setValue(PasswordCache().m_pwexpire);
    settings->setConfiguraton( m_configuration);

    if (!settings) return;
    settings->show();
    settings->exec();
    */
}





void KWlanMainWin::helpAbout()
{
    KAboutApplication about(this);
    about.exec();
}


void KWlanMainWin::fileExit()
{
    //m_configuration->writeSettings();
    kdDebug() << "Exiting..." << endl;
    kapp->quit();
}



void KWlanMainWin::updateDialupNetworks()
{
    kdDebug() << "Updating dialup networks" << endl;
    QStringList networks = listDialupNetworks();
    lbDialup->clear();
    for (QStringList::iterator it = networks.begin();it != networks.end();it++)
    {
        lbDialup->insertItem(*it);
    }
}


void KWlanMainWin::close()
{
    Kwlan::close();
}


void KWlanMainWin::ifconfigProcessExited( KProcess* process )
{
    //QMap<QString, QString> configs;
    if (process != m_ifconfigProcess) return;
    delete m_ifconfigProcess;
    m_ifconfigProcess=0L;
    QStringList ifList = QStringList::split( "\n\n", m_ifconfigStdout );
    QStringList::Iterator it;
    mainConfiguration conf;
    for ( it = ifList.begin(); it != ifList.end(); ++it )
    {
        int index = ( *it ).find( ' ' );
        if ( index == -1 )
            continue;
       // QString key = ( *it ).left( index );
        //configs[key] = ( *it ).mid( index );
        
        if ( (*it).mid(index).contains( "Ethernet" ))// || (*it).mid(index).contains( "Point-to-Point" ))
        {
            QString iface = (*it).left(index);
            if ( m_interfaces.findIndex(iface) == -1)
            {
                KWlanInterface *widget = new KWlanInterface();
                widget->init(iface );
                connect (widget, SIGNAL(interfaceGone(QString)), this, SLOT(slotInterfaceGone( QString)));
                
                KWlanTrayWin *trayWin = new KWlanTrayWin(this,"KWlan");
                trayWin->setInterface(widget);
                trayWin->setInterfaceName(iface);
    //m_traywin->setProfile(m_network);
                connect(trayWin, SIGNAL( quitSelected() ), this, SLOT( fileExit() ) );
                connect(trayWin, SIGNAL (aboutSelected()),this,SLOT(helpAbout()));
                connect (m_tray, SIGNAL(sigMonitorInterface(QString, bool)), trayWin, SLOT(slotShowTrayWin(QString,bool)));
                if (conf.readMonitorInterface(iface)) trayWin->show();
                
                m_interfaces.append(iface);
                kdDebug() << "Added interface " << iface << endl;
            }
        }
    }
}

void KWlanMainWin::ifconfigProcessStdout( KProcess* process, char* buffer, int buflen )
{
    m_ifconfigStdout += QString::fromLatin1( buffer, buflen );
}

void KWlanMainWin::slotInterfaceGone(QString iface)
{
    kdDebug() << "Lost interface " << iface << endl;
    int id = m_interfaces.findIndex(iface);
    if (id!=-1)
        m_interfaces.remove(m_interfaces.at(id));
}

#include "kwlanmainwin.moc"


















